import ev3dev, time

#motor control
def motorstop(m):
    m.stop()

def motorrun(m):
    m.connected
    m.run_forever(duty_cycle_sp=20)

#calibrate color before first run
def calibrate(t, c, l):
    l.clear()
    l.draw.text((2, 8), 'light droid first...')
    l.update()
    while (t.value() == 0):
        l.draw.rectangle([2,20,100,28],fill="white")
        l.draw.text((2, 20), 'color = ' + str(c.value()))
        l.update()
    l.update()
    dlight = c.value()
    ev3dev.Sound.beep()
    time.sleep(2.0)
    l.clear()
    l.draw.text((2, 8), 'dark droid next...')
    l.update()
    while (t.value() == 0):
        l.draw.rectangle([2,20,100,28],fill="white")
        l.draw.text((8, 20), 'color = ' + str(c.value()))
        l.update()
    l.update()
    ddark = c.value()
    ev3dev.Sound.beep()
    return [dlight, ddark]

#-------------------------------------------------
#prepare sensors, display and calibrate
t = ev3dev.TouchSensor()
c = ev3dev.ColorSensor()
c.mode = 'COL-REFLECT'
l = ev3dev.LCD()
l.clear()
calvalues = calibrate(t,c,l)
l.clear()
l.draw.text((2,20),str(calvalues[0])+' : '+str(calvalues[1]))
l.update()
time.sleep(3.0)
l.clear()
l.draw.text((2,20),'FACTORY IS READY TO RUN!')
l.update()
ev3dev.Sound.beep()
time.sleep(0.25)
ev3dev.Sound.beep()
#wait for button press
while (t.value() == 0):
    time.sleep(0.01)
time.sleep(0.5)
#prepare variables
dlight = 0  #counter for light droids
ddark = 0   #counter for dark droids
factoryclosed = False
#then run motor driven belt
m = ev3dev.LargeMotor('outD')
motorrun(m)
while (not factoryclosed):
    #wait for droid or button press
    isnewdroid = c.value()
    wasbuttonpressed = t.value()
    while (isnewdroid < calvalues[1]) and (wasbuttonpressed == 0):
        isnewdroid = c.value()
        wasbuttonpressed = t.value()
    #what happened?
    l.clear()
    if (wasbuttonpressed):
        l.draw.text((2,8), 'STOP!')
        l.update()
        motorstop(m)
        factoryclosed = True
    else:
        #necessary to stop and properly scan the droid color
        motorstop(m)
        time.sleep(0.25)
        isnewdroid = c.value()
        if (isnewdroid <= calvalues[1]+4):
            l.draw.text((2,20), 'dark one '+str(isnewdroid)+'-'+str(calvalues[1]))
            ddark += 1
        else:
            l.draw.text((2,20), 'light one '+str(isnewdroid)+'-'+str(calvalues[0]))
            dlight +=1
        l.draw.text((2,8),'L = '+str(dlight)+' | D = '+str(ddark))
        l.update()
        motorrun(m)
        time.sleep(0.4)
#factory is closing
time.sleep(2.0)
l.clear()
l.draw.text((2,8), 'FACTORY CLOSED')
l.draw.text((2,20), 'overall production:')
l.draw.text((2,32),'L = '+str(dlight)+' | D = '+str(ddark))
l.update()
time.sleep(3.0)
